/*
 © 2024 SMARTYADS, LDA doing business as “TEQBLAZE”.  All rights reserved.
 You may not use this file except in compliance with the applicable license granted to you by SMARTYADS, LDA doing business as “TEQBLAZE” (the "License").
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 Specific authorizations and restrictions shall be provided for in the License.
 */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the Appstock repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

//Superclass
#import <Foundation/Foundation.h>

#import "TQBAdLoadManagerDelegate.h"
#import "TQBAdViewManagerDelegate.h"
#import "TQBCreativeViewDelegate.h"

@class TQBModalManager;
@class TQBAdConfiguration;
@class AppstockAdFormat;
@protocol TQBModalManagerDelegate;
@protocol AppstockServerConnectionProtocol;

NS_ASSUME_NONNULL_BEGIN
@interface TQBAdViewManager: NSObject <TQBCreativeViewDelegate>

@property (nonatomic, strong) TQBAdConfiguration *adConfiguration;
@property (nonatomic, strong) TQBModalManager *modalManager;
@property (nonatomic, weak, nullable) id<TQBAdViewManagerDelegate> adViewManagerDelegate;
@property (nonatomic, assign) BOOL autoDisplayOnLoad;
@property (nonatomic, readonly) BOOL isCreativeOpened;

@property (nonatomic, readonly, getter=isMuted) BOOL muted;

- (instancetype)init NS_UNAVAILABLE;
- (instancetype)initWithConnection:(id<AppstockServerConnectionProtocol>)connection
              modalManagerDelegate:(nullable id<TQBModalManagerDelegate>)modalManagerDelegate NS_DESIGNATED_INITIALIZER;

- (nullable NSString*)revenueForNextCreative;

// Indicates whether the manager has all the needed data to show the add.
// If NO then the show method will not lead to displaying the ad.
- (BOOL)isAbleToShowCurrentCreative;

- (void)show;
- (void)pause;
- (void)resume;

- (void)mute;
- (void)unmute;


- (void)handleExternalTransaction:(TQBTransaction *)transaction;

@end
NS_ASSUME_NONNULL_END
