/*
 © 2024 SMARTYADS, LDA doing business as “TEQBLAZE”.  All rights reserved.
 You may not use this file except in compliance with the applicable license granted to you by SMARTYADS, LDA doing business as “TEQBLAZE” (the "License").
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 Specific authorizations and restrictions shall be provided for in the License.
 */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the Appstock repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <UIKit/UIKit.h>

@interface UIView (TQBExtensions)

- (void)TQBAddFillSuperviewConstraints
    NS_SWIFT_NAME(TQBAddFillSuperviewConstraints());

- (void)TQBAddConstraintsFromCGRect:(CGRect)rect
    NS_SWIFT_NAME(TQBAddConstraintsFromCGRect(_:));

- (void)TQBAddCropAndCenterConstraintsWithInitialWidth:(CGFloat)initialWidth initialHeight:(CGFloat)initialHeight
    NS_SWIFT_NAME(TQBAddCropAndCenterConstraints(initialWidth:initialHeight:));

- (void)TQBAddBottomRightConstraintsWithMarginSize:(CGSize)marginSize;

- (void)TQBAddBottomRightConstraintsWithViewSize:(CGSize)viewSize marginSize:(CGSize)marginSize
    NS_SWIFT_NAME(TQBAddBottomRightConstraints(viewSize:marginSize:));

- (void)TQBAddBottomLeftConstraintsWithViewSize:(CGSize)viewSize marginSize:(CGSize)marginSize
    NS_SWIFT_NAME(TQBAddBottomLeftConstraints(viewSize:marginSize:));

- (void)TQBAddTopRightConstraintsWithViewSize:(CGSize)viewSize marginSize:(CGSize)marginSize
    NS_SWIFT_NAME(TQBAddTopRightConstraints(viewSize:marginSize:));

- (void)TQBAddTopLeftConstraintsWithViewSize:(CGSize)viewSize marginSize:(CGSize)marginSize
    NS_SWIFT_NAME(TQBAddTopLeftConstraints(viewSize:marginSize:));

- (void)LogViewHierarchy;

- (BOOL)tqbIsVisible;

- (BOOL)tqbIsVisibleInView:(UIView *)inView;

- (BOOL)tqbIsVisibleInViewLegacy:(UIView *)inView;

@end
