/*
 © 2024 SMARTYADS, LDA doing business as “TEQBLAZE”.  All rights reserved.
 You may not use this file except in compliance with the applicable license granted to you by SMARTYADS, LDA doing business as “TEQBLAZE” (the "License").
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 Specific authorizations and restrictions shall be provided for in the License.
 */

/*   Copyright 2018-2021 Prebid.org, Inc.

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 CHANGE NOTICE: The file content was modified to rebrand the work, adapt the product for the new use case, and change the distribution license.
 The patch to the original code is available in the Appstock repository.
 All changes after applying the patch are made under the new license and copyrights mentioned at the beginning of this file.
*/

#import <Foundation/Foundation.h>
#import "TQBORTBBidExtSkadn.h"

@protocol TQBTransactionDelegate;

@class WKWebView;
@class UIView;
@class TQBModalManager;
@class TQBAdConfiguration;
@class TQBCreativeModel;
@class TQBAbstractCreative;
@class TQBAdDetails;
@class TQBOpenMeasurementSession;
@class TQBOpenMeasurementWrapper;
@class TQBORTBBidExtSkadn;

@protocol AppstockServerConnectionProtocol;

NS_ASSUME_NONNULL_BEGIN
@interface TQBTransaction: NSObject

@property (nonatomic, readonly, nonnull) TQBAdConfiguration *adConfiguration; // If need to change use resetAdConfiguration
@property (nonatomic, strong) NSMutableArray<TQBAbstractCreative *> *creatives;
@property (nonatomic, strong) NSArray<TQBCreativeModel *> *creativeModels;
@property (nonatomic, strong, nullable) TQBOpenMeasurementSession *measurementSession;
@property (nonatomic, strong) TQBOpenMeasurementWrapper *measurementWrapper;

@property (nonatomic, strong, nullable) TQBORTBBidExtSkadn *skadnInfo;
@property (nonatomic, strong, nullable) NSString *impURL; // bidResponse.ext.mobilesdk.events.imp
@property (nonatomic, strong, nullable) NSString *winURL; // bidResponse.ext.mobilesdk.events.win

@property (atomic, weak, nullable) id<TQBTransactionDelegate> delegate;

- (instancetype)init NS_UNAVAILABLE;
- (instancetype)initWithServerConnection:(id<AppstockServerConnectionProtocol>)connection
                         adConfiguration:(TQBAdConfiguration *)adConfiguration
                                  models:(NSArray<TQBCreativeModel *> *)creativeModels NS_DESIGNATED_INITIALIZER;

- (void)startCreativeFactory;
- (nullable TQBAdDetails *)getAdDetails;
- (nullable TQBAbstractCreative *)getFirstCreative;
- (nullable TQBAbstractCreative *)getCreativeAfter:(TQBAbstractCreative *)creative;
- (nullable NSString*)revenueForCreativeAfter:(TQBAbstractCreative *)creative;
- (void)resetAdConfiguration:(TQBAdConfiguration *)adConfiguration;

@end
NS_ASSUME_NONNULL_END
